#pragma once
#include <vector>
#include <unordered_map>
#include "map.hpp"
#include "dinkyecs.hpp"
#include <tuple>

struct PointHash {
  size_t operator()(const Point& p) const {
    return std::hash<int>()(p.x) ^ std::hash<int>()(p.y);
  }
};

typedef std::vector<DinkyECS::Entity> FoundList;

class SpatialHashTable {
  public:
    SpatialHashTable() {}

    // disable copying, I think?
    SpatialHashTable(SpatialHashTable &other) = delete;

    void insert(Point pos, DinkyECS::Entity obj);
    void move(Point from, Point to, DinkyECS::Entity ent);
    void remove(Point pos);
    bool occupied(Point pos);

    std::tuple<bool, FoundList> neighbors(Point position);

  private:
    std::unordered_map<Point, DinkyECS::Entity, PointHash> table;
};
